#include<bits/stdc++.h>
using namespace std;
int read(){
	int x=0,f=1;
	char ch=getchar();
	while(ch<'0'||ch>'9'){
		if(ch=='-') f=-1;
		ch=getchar();
	}
	while(ch<='9'&&ch>='0'){
		x=(x<<3)+(x<<1)+(ch^48);
		ch=getchar();
	}
	return x*f;
}
const int N=500005,M=1e9+7;
struct node{
	int x,y;
}f[N];
//int o,first[N];
//void add(int x,int y){
//	f[++o].to=y,f[o].ne=first[x],first[x]=o;
//}
int fa[N];
int find(int x){
	if(fa[x]==x) return x;
	else return fa[x]=find(fa[x]);
}
long long fapow(int x,int y){
	long long ans=1;
	while(y>0){
		if(y&1) ans*=x;
		x*=x;
		y>>=1;
	}
	return ans;
}
long long st[N],ny[N];
int x,y;
void exgcd(int a,int b){
	if(b==0){
		x=0,y=1;
		return;
	}
	exgcd(b,a%b);
	int tx=x;
	x=y,y=a/b*y;
}
int main(){
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	int n=read(),m=read();
	for(int i=1;i<=m;i++){
		f[i].x=read(),f[i].y=read();
	}
	if(m<=5000){
		long long ans=0;
		for(int i=1;i<(1<<n);i++){
			for(int j=0;j<(1<<m);j++){
				for(int k=1;k<=n;k++) fa[k]=k;
				for(int k=1;k<=m;k++){
					if((1<<(k-1))&j){
						int x=find(f[k].x);
						int y=find(f[k].y);
						if(x!=y) fa[x]=y;
					}
				}
				int judg=1,num=0;
				for(int k=1;k<=n;k++){
					if((1<<(k-1))&i){
						if(num==0) num=find(k);
						else if(find(k)!=num){
							judg=0;
							break;
						}
					}
				}
				if(judg==1) ans++;
			}
		}
		printf("%lld",ans);
	}
	else{
		long long ans=0;
		st[1]=1;ny[1]=1;
		st[0]=1,ny[0]=1;
		for(int i=2;i<=n;i++){
			st[i]=st[i-1]*i;
			st[i]%=M;
			exgcd(st[i],M);
			ny[i]=(x%M+M)%M;
		}
		for(int i=1;i<=n;i++){
			ans=ans+st[n]*ny[n-i]*ny[i];
			ans%=M;
		}
		printf("%lld",ans);
	}
	return 0;
}